from PIL import Image
from PIL import ImageOps
import re
import webbrowser
 
if __name__ == '__main__':
    img = Image.open(input("Image path: "))
    name = "secret message"
    while len(name) > 8 or not re.match("^[A-Z0-9]*$", name) or not re.match("^[A-Z]*$", name[0]):
        name = input("Image name in calculator[A-Z][0-9][1-8 characters][Must start with a letter]:")
        if not re.match("^[A-Z]*$", name[0]):
            print("Name must have a letter as the starting character")
        if not re.match("^[A-Z0-9]*$", name):
            print("Name must only use capital letters and numbers")
        if len(name) > 8:
            print("Name must be 1 to 8 characters")
    width, height = img.size
    print("Image size is", width, "pixels by", height, "pixels")
    if width != 96 and height != 64:
        print("Image is not 96 pixels by 64 pixels, resizing...")
        img = img.resize((96, 64))
    print("converting to grayscale...")
    img = img.convert("L")
    print("posterizing...")
    img = ImageOps.posterize(img, 2)
    #img.save("output.png")
    program = open("output.txt","w+")
    program.write("." + name + "\nRepeat getKey(15)\n")
    pxlist = list(img.getdata())
    pxlist = [4-x/64 for x in pxlist]
    print("converting image to sprites and writing to output.txt")
    for j in range(0,96,8):
        for i in range(0,6144,768):
            bufferbin = ""
            mainbin = ""
            bufferhex = ""
            mainhex = ""
            for k in range(0,768,96):
                for l in range(0,8):
                    if pxlist[i+k+j+l] == 1:
                        bufferbin += "0"
                        mainbin += "0"
                    if pxlist[i+k+j+l] == 2:
                        bufferbin += "1"
                        mainbin += "0"
                    if pxlist[i+k+j+l] == 3:
                        bufferbin += "0"
                        mainbin += "1"
                    if pxlist[i+k+j+l] == 4:
                        bufferbin += "1"
                        mainbin += "1"
                    if len(mainbin) == 4:
                        mainhex += '%0*X' % ((len(mainbin) + 3) // 4, int(mainbin, 2))
                        bufferhex += '%0*X' % ((len(bufferbin) + 3) // 4, int(bufferbin, 2))
                        mainbin = ""
                        bufferbin = ""
            if mainhex != "0000000000000000":
                program.write("Pt-On(" + str(int(j)) + "," + str(int(i/96)) + ",[" + mainhex + "])\n")
            if bufferhex != "0000000000000000":
            	program.write("Pt-On(" + str(int(j)) + "," + str(int(i/96)) + ",[" + bufferhex + "])^^r\n")
    program.write("DispGraph^^r^^r\nClrDraw^^r\nEnd")
    program.close()
    print("\n\nDONE!\nPaste the code from 'output.txt' into Cemetech's SourceCoder 3 IDE and export the program onto your calculator and compile with Axe.")
    webbrowser.open('https://www.cemetech.net/sc/')